searchNodes=[{"doc":"","ref":"Clik.html","title":"Clik","type":"module"},{"doc":"CLI execution entry point. Parses CLI args based on the configuration and calls the correct command. run/2 should be called from the main function. Example defmodule MyCLIApp do alias Clik.Configuration def main ( args ) do config = Configuration . add_command! ( % Configuration { } , Command . new! ( :default , MyCLIApp.DefaultCommand ) ) case Clik . run ( config , args ) do :ok -&gt; :erlang . halt ( 0 ) { :error , reason } -&gt; :erlang . halt ( 1 ) end end","ref":"Clik.html#run/3","title":"Clik.run/3","type":"function"},{"doc":"Raw args from CLI","ref":"Clik.html#t:argv/0","title":"Clik.argv/0","type":"type"},{"doc":"Error during arg parsing or command dispatch","ref":"Clik.html#t:error/0","title":"Clik.error/0","type":"type"},{"doc":"Execution result","ref":"Clik.html#t:result/0","title":"Clik.result/0","type":"type"},{"doc":"","ref":"Clik.Command.html","title":"Clik.Command","type":"behaviour"},{"doc":"Returns short help blurb","ref":"Clik.Command.html#c:help_text/0","title":"Clik.Command.help_text/0","type":"callback"},{"doc":"Fetch command implementation's help blurb.","ref":"Clik.Command.html#help_text/1","title":"Clik.Command.help_text/1","type":"function"},{"doc":"Creates a new Clik.Command instance. Returns {:error, :badarg} if: name or callback_module are nil Loading callback_module via Code.ensure_loaded/1 fails","ref":"Clik.Command.html#new/3","title":"Clik.Command.new/3","type":"function"},{"doc":"Creates a new Clik.Command instance. Raises ArgumentError if: name or callback_module are nil Loading callback_module via Code.ensure_loaded/1 fails","ref":"Clik.Command.html#new!/3","title":"Clik.Command.new!/3","type":"function"},{"doc":"Returns list of command-specific options","ref":"Clik.Command.html#c:options/0","title":"Clik.Command.options/0","type":"callback"},{"doc":"Fetch list of command-specific options.","ref":"Clik.Command.html#options/1","title":"Clik.Command.options/1","type":"function"},{"doc":"Executes the command","ref":"Clik.Command.html#c:run/1","title":"Clik.Command.run/1","type":"callback"},{"doc":"Executes a command.","ref":"Clik.Command.html#run/2","title":"Clik.Command.run/2","type":"function"},{"doc":"List of command options","ref":"Clik.Command.html#t:option_map/0","title":"Clik.Command.option_map/0","type":"type"},{"doc":"","ref":"Clik.Command.html#t:result/0","title":"Clik.Command.result/0","type":"type"},{"doc":"An executable command","ref":"Clik.Command.html#t:t/0","title":"Clik.Command.t/0","type":"type"},{"doc":"","ref":"Clik.CommandEnvironment.html","title":"Clik.CommandEnvironment","type":"module"},{"doc":"Creates a new Clik.CommandEnvironment instance. Input, output, and error default to stdin, stdout, and stderr respectively.","ref":"Clik.CommandEnvironment.html#new/2","title":"Clik.CommandEnvironment.new/2","type":"function"},{"doc":"Individual options used to configure a Clik.CommandEnvironment","ref":"Clik.CommandEnvironment.html#t:opt/0","title":"Clik.CommandEnvironment.opt/0","type":"type"},{"doc":"","ref":"Clik.CommandEnvironment.html#t:opts/0","title":"Clik.CommandEnvironment.opts/0","type":"type"},{"doc":"Script name, parsed options, and arguments","ref":"Clik.CommandEnvironment.html#t:t/0","title":"Clik.CommandEnvironment.t/0","type":"type"},{"doc":"Collects commands and global options.","ref":"Clik.Configuration.html","title":"Clik.Configuration","type":"module"},{"doc":"Add a command to the application configuration. Returns {:error, :duplicate_command} or {:error, :duplication_option, option} on error.","ref":"Clik.Configuration.html#add_command/2","title":"Clik.Configuration.add_command/2","type":"function"},{"doc":"Add a command to the application configuration. Raises Clik.DuplicateCommandNameError or Clik.DuplicateOptionError on error.","ref":"Clik.Configuration.html#add_command!/2","title":"Clik.Configuration.add_command!/2","type":"function"},{"doc":"Add a global option to the application configuration. Returns {:error, :duplicate} on error.","ref":"Clik.Configuration.html#add_global_option/2","title":"Clik.Configuration.add_global_option/2","type":"function"},{"doc":"Add a global option to the application configuration. Raises Clik.DuplicateOptionError on error.","ref":"Clik.Configuration.html#add_global_option!/2","title":"Clik.Configuration.add_global_option!/2","type":"function"},{"doc":"Look up Clik.Command by name. Returns {:error, :unknown_command} if name is not found.","ref":"Clik.Configuration.html#command/2","title":"Clik.Configuration.command/2","type":"function"},{"doc":"Look up Clik.Command by name. Raises Clik.UnknownCommandNameError if name is not found.","ref":"Clik.Configuration.html#command!/2","title":"Clik.Configuration.command!/2","type":"function"},{"doc":"Does the configuration contain a named command?","ref":"Clik.Configuration.html#has_command?/2","title":"Clik.Configuration.has_command?/2","type":"function"},{"doc":"Creates a new Clik.Configuration instance","ref":"Clik.Configuration.html#new/1","title":"Clik.Configuration.new/1","type":"function"},{"doc":"Fetch complete set of options for a given named command. The complete set of options includes options specific to the command and global options. Returns {:error, :unknown_command} when command name is not found.","ref":"Clik.Configuration.html#options/2","title":"Clik.Configuration.options/2","type":"function"},{"doc":"Fetch complete set of options for a given named command. See Clik.Configuration.options/2 for more information. Raises Clik.UnknownCommandNameError when command not found.","ref":"Clik.Configuration.html#options!/2","title":"Clik.Configuration.options!/2","type":"function"},{"doc":"Global CLI app configuration","ref":"Clik.Configuration.html#t:t/0","title":"Clik.Configuration.t/0","type":"type"},{"doc":"Configurable CLI flag.","ref":"Clik.Option.html","title":"Clik.Option","type":"module"},{"doc":"Creates a new Clik.Option instance. Returns {:ok, t} or {:error, reason} .","ref":"Clik.Option.html#new/2","title":"Clik.Option.new/2","type":"function"},{"doc":"Creates a new Clik.Option instance. Raises ArgumentError on error.","ref":"Clik.Option.html#new!/2","title":"Clik.Option.new!/2","type":"function"},{"doc":"","ref":"Clik.Option.html#t:error/0","title":"Clik.Option.error/0","type":"type"},{"doc":"Individual options used to configure an instance of Clik.Option","ref":"Clik.Option.html#t:opt/0","title":"Clik.Option.opt/0","type":"type"},{"doc":"Valid option types","ref":"Clik.Option.html#t:option_type/0","title":"Clik.Option.option_type/0","type":"type"},{"doc":"Valid option value types","ref":"Clik.Option.html#t:option_value/0","title":"Clik.Option.option_value/0","type":"type"},{"doc":"Set of configuration options used to configure an instance of Clik.Option","ref":"Clik.Option.html#t:opts/0","title":"Clik.Option.opts/0","type":"type"},{"doc":"Struct corresponding to a single CLI flag or switch","ref":"Clik.Option.html#t:t/0","title":"Clik.Option.t/0","type":"type"},{"doc":"Formatted terminal output.","ref":"Clik.Output.Document.html","title":"Clik.Output.Document","type":"module"},{"doc":"Creates a new empty document","ref":"Clik.Output.Document.html#empty/0","title":"Clik.Output.Document.empty/0","type":"function"},{"doc":"Add a line to a document","ref":"Clik.Output.Document.html#line/3","title":"Clik.Output.Document.line/3","type":"function"},{"doc":"Adds a section header to a document","ref":"Clik.Output.Document.html#section_head/3","title":"Clik.Output.Document.section_head/3","type":"function"},{"doc":"Add table to document","ref":"Clik.Output.Document.html#table/2","title":"Clik.Output.Document.table/2","type":"function"},{"doc":"Adds a block of text to a document","ref":"Clik.Output.Document.html#text/3","title":"Clik.Output.Document.text/3","type":"function"},{"doc":"","ref":"Clik.Output.Document.html#t:code/0","title":"Clik.Output.Document.code/0","type":"type"},{"doc":"","ref":"Clik.Output.Document.html#t:doc_entries/0","title":"Clik.Output.Document.doc_entries/0","type":"type"},{"doc":"","ref":"Clik.Output.Document.html#t:t/0","title":"Clik.Output.Document.t/0","type":"type"},{"doc":"","ref":"Clik.Output.Formatters.CommandHelp.html","title":"Clik.Output.Formatters.CommandHelp","type":"module"},{"doc":"","ref":"Clik.Output.Formatters.CommandHelp.html#format/3","title":"Clik.Output.Formatters.CommandHelp.format/3","type":"function"},{"doc":"","ref":"Clik.Output.Formatters.GlobalHelp.html","title":"Clik.Output.Formatters.GlobalHelp","type":"module"},{"doc":"","ref":"Clik.Output.Formatters.GlobalHelp.html#format/2","title":"Clik.Output.Formatters.GlobalHelp.format/2","type":"function"},{"doc":"","ref":"Clik.Output.Formatters.Options.html","title":"Clik.Output.Formatters.Options","type":"module"},{"doc":"","ref":"Clik.Output.Formatters.Options.html#format_help/1","title":"Clik.Output.Formatters.Options.format_help/1","type":"function"},{"doc":"","ref":"Clik.Output.Formatters.Options.html#format_name/2","title":"Clik.Output.Formatters.Options.format_name/2","type":"function"},{"doc":"","ref":"Clik.Output.Formatters.SingleCommandHelp.html","title":"Clik.Output.Formatters.SingleCommandHelp","type":"module"},{"doc":"","ref":"Clik.Output.Formatters.SingleCommandHelp.html#format/2","title":"Clik.Output.Formatters.SingleCommandHelp.format/2","type":"function"},{"doc":"","ref":"Clik.Output.HelpFormatter.html","title":"Clik.Output.HelpFormatter","type":"module"},{"doc":"","ref":"Clik.Output.HelpFormatter.html#command_help!/2","title":"Clik.Output.HelpFormatter.command_help!/2","type":"function"},{"doc":"","ref":"Clik.Output.HelpFormatter.html#script_help/1","title":"Clik.Output.HelpFormatter.script_help/1","type":"function"},{"doc":"","ref":"Clik.Output.Table.html","title":"Clik.Output.Table","type":"module"},{"doc":"","ref":"Clik.Output.Table.html#add_row/2","title":"Clik.Output.Table.add_row/2","type":"function"},{"doc":"","ref":"Clik.Output.Table.html#empty/2","title":"Clik.Output.Table.empty/2","type":"function"},{"doc":"","ref":"Clik.Output.Table.html#empty?/1","title":"Clik.Output.Table.empty?/1","type":"function"},{"doc":"","ref":"Clik.Output.Table.html#size/1","title":"Clik.Output.Table.size/1","type":"function"},{"doc":"","ref":"Clik.Output.Table.html#t:colnum/0","title":"Clik.Output.Table.colnum/0","type":"type"},{"doc":"","ref":"Clik.Output.Table.html#t:format_hint/0","title":"Clik.Output.Table.format_hint/0","type":"type"},{"doc":"","ref":"Clik.Output.Table.html#t:t/0","title":"Clik.Output.Table.t/0","type":"type"},{"doc":"Formatted block of text. Represents either a partial or full line of text. Lines are terminated with the correct terminator based on platform.","ref":"Clik.Output.Text.html","title":"Clik.Output.Text","type":"module"},{"doc":"","ref":"Clik.Output.Text.html#append/2","title":"Clik.Output.Text.append/2","type":"function"},{"doc":"","ref":"Clik.Output.Text.html#format/1","title":"Clik.Output.Text.format/1","type":"function"},{"doc":"","ref":"Clik.Output.Text.html#new/3","title":"Clik.Output.Text.new/3","type":"function"},{"doc":"","ref":"Clik.Output.Text.html#t:t/0","title":"Clik.Output.Text.t/0","type":"type"},{"doc":"Renders term and writes the resulting string to out .","ref":"Clik.Renderable.html","title":"Clik.Renderable","type":"protocol"},{"doc":"","ref":"Clik.Renderable.html#render/2","title":"Clik.Renderable.render/2","type":"function"},{"doc":"","ref":"Clik.Renderable.html#t:t/0","title":"Clik.Renderable.t/0","type":"type"},{"doc":"","ref":"Clik.Renderable.html#t:target/0","title":"Clik.Renderable.target/0","type":"type"},{"doc":"","ref":"Clik.DuplicateCommandNameError.html","title":"Clik.DuplicateCommandNameError","type":"exception"},{"doc":"Indicates a command with the same name already exists.","ref":"Clik.DuplicateCommandNameError.html#__struct__/0","title":"Clik.DuplicateCommandNameError.__struct__/0","type":"function"},{"doc":"","ref":"Clik.DuplicateOptionError.html","title":"Clik.DuplicateOptionError","type":"exception"},{"doc":"Indicates an option, either global or command, has been duplicated.","ref":"Clik.DuplicateOptionError.html#__struct__/0","title":"Clik.DuplicateOptionError.__struct__/0","type":"function"},{"doc":"","ref":"Clik.UnknownCommandNameError.html","title":"Clik.UnknownCommandNameError","type":"exception"},{"doc":"Indicates an attempt was made to use a unknown command","ref":"Clik.UnknownCommandNameError.html#__struct__/0","title":"Clik.UnknownCommandNameError.__struct__/0","type":"function"},{"doc":"","ref":"readme.html","title":"README","type":"extras"},{"doc":"Clik is a library designed to simplify writing CLI apps in Elixir. Clik handles important but tedious tasks like handling CLI options and generating useful help output. A complete Mix project which demonstrates how to build a CLI app with Clik is available here .","ref":"readme.html#what-is-clik","title":"README - What is Clik?","type":"extras"},{"doc":"defmodule HelloClik do use Clik.Command alias Clik.{Command, CommandEnvironment, Configuration, Option, Platform} alias Clik.Renderable alias Clik.Output.Table def help_text(), do: &quot;Say hello to the world&quot; def options() do %{ verbose: Option.new!(:verbose, short: :v, type: :boolean, help: &quot;Be verbose&quot;), table: Option.new!(:table, short: :t, type: :boolean, help: &quot;Use a table&quot;) } end def run(env) do use_tables = Keyword.get(env.options, :table, false) greeting = if Keyword.get(env.options, :verbose, false) == true do &quot;Greetings and salutations!&quot; else &quot;Hello!&quot; end write_output(use_tables, greeting, env.output) end defp write_output(false, greeting, out) do IO.puts(out, greeting) end defp write_output(true, greeting, out) do t = Table.empty(2, [&quot;Type&quot;, &quot;Phrase&quot;]) |&gt; Table.add_row([&quot;Greeting&quot;, greeting]) Renderable.render(t, out) end def main(args) do config = Configuration.add_command!( Configuration.new(), Command.new!(:hello, __MODULE__) ) env = CommandEnvironment.new(Platform.script_name()) Clik.run(config, args, env) end end","ref":"readme.html#brief-example","title":"README - Brief example","type":"extras"},{"doc":"Percentage | Module -- -- -- -- -- - | -- -- -- -- -- -- -- -- -- -- -- -- -- 66.67 % | Clik.CommandEnvironment 73.68 % | Clik.Platform 74.51 % | Clik 80.00 % | Clik.Command 80.00 % | Clik.Renderable.Clik.Output.Document 84.85 % | Clik.Output.Formatters.Options 85.19 % | Clik.Output.Formatters.SingleCommandHelp 85.71 % | Clik.Output.Formatters.CommandHelp 90.91 % | Clik.Output.Document 90.91 % | Clik.Output.Text 93.75 % | Clik.Option 94.74 % | Clik.Output.Table 96.49 % | Clik.Configuration 100.00 % | Clik.DuplicateCommandNameError 100.00 % | Clik.Output.Formatters.GlobalHelp 100.00 % | Clik.Output.HelpFormatter 100.00 % | Clik.Renderable.Clik.Output.Table 100.00 % | Clik.Renderable.Clik.Output.Text 100.00 % | Clik.Test.LinuxDetector 100.00 % | Clik.Test.MacDetector 100.00 % | Clik.Test.Windows32BitDetector 100.00 % | Clik.Test.WindowsNTDetector 100.00 % | Clik.UnknownCommandNameError 100.00 % | String.Chars.Clik.Output.Text -- -- -- -- -- - | -- -- -- -- -- -- -- -- -- -- -- -- -- 88.95 % | Total","ref":"readme.html#testing","title":"README - Testing","type":"extras"}]